#!/usr/bin/ruby
# 2013-09-11 14:03

# This does not do the corrected sample standard deviation (n-1).
# descriptive_statistics-1.1.1.gem from https://github.com/thirtysixthspan/descriptive_statistics 2013-05-14 13:58
# gem install descriptive_statistics-1.1.1.gem
# require 'descriptive_statistics'

def sum(x)
  x.inject(:+).to_f
end

def mean(x)
  sum(x)/x.size
end

def sd(x)
  xm = mean(x)
  v = x.map{ |sample| (xm - sample) ** 2 }.inject(:+) / (x.size - 1.0)
  Math.sqrt(v)
end

# convert returns a triplet (actually an Array of size 3) of Arrays.  The
# first one contains the sample counts from fn1; the second from fn2; the
# third is the total sample count of the run.
def convert(logq2,hz)
  triplet = Array.new(3) { Array.new }
  q = (10 ** (logq2/2.0) + 0.5).to_i
  fname = "q=" + q.to_s + "_HZ=" + hz + "_perf.txt"
  File.open(fname,"r") do |file|
    state = 0
    bign = 0
    # For perf, the "Event count (approx.)" looks to be identical to the
    # sum of the sample counts in this case.
    file.lines do |line|
      line.chomp!
      if line[0] != "#" && line.size > 0
        state = 1
        raise "Perf input format error" if line[0] != " "
        ls = line.split(' ')
        samplecount = ls[1].to_i
        bign += samplecount
        case ls.last
          when "fn1" then triplet[0].push(samplecount)
	  when "fn2" then triplet[1].push(samplecount)
        end
      else
        if state == 1
          triplet[2].push(bign)
          bign = 0
          state = 0
        end
      end
    end
    if state == 1
      triplet[2].push(bign)
    end
  end
  # FIXME for p=0
  raise "Sample count mismatch 1" if triplet[0].size != triplet[1].size
  raise "Sample count mismatch 2" if triplet[0].size != triplet[2].size
  raise "Wrong sample count" if triplet[0].size != 1000
  triplet
end

# i & 0F  = logq*2  (0..14, 15 is unused)
# i & 10  = hz  (0=100,1=1000)
# i & 20  = p   (0=0.2(fn1), 1=0.8(fn2))
data = Array.new(63) { Array.new }
bign = Array.new(31) { Array.new }
(0..31).each do |i|
  logq2 = i&0xF
  if logq2 < 15
    hz = i&0x10==0 ? "100" : "1000"
    triplet = convert(logq2,hz)
    data[i] = triplet[0]
    data[i+0x20] = triplet[1]
    bign[i] = triplet[2]
  end
end

crunched = File.open("data-summary.txt","w")
crunched.puts "logq2 hz p count mean sd"
dump = File.open("data-denormalized.txt","w")
dump.puts "logq2 hz p sample"
bignfile = File.open("data-bign.txt","w")
bignfile.puts "logq2 hz bign"
(0..62).each do |i|
  logq2 = i&0xF
  if logq2 < 15
    hz = i&0x10==0 ? "0" : "1"
    p  = i&0x20==0 ? "0" : "1"
    crunched.puts logq2.to_s + " " + hz + " " + p + " " + data[i].size.to_s + " " + mean(data[i]).to_s + " " + sd(data[i]).to_s
    if (i < 31)
      bign[i].each {|x| bignfile.print logq2, " ", hz, " ", x, "\n" }
    end
    data[i].each {|x| dump.print logq2, " ", hz, " ", p, " ", x, "\n" }
  end
end
