# 2013-06-13 13:45
# R --vanilla -f plot-slowdown-scattersums.R

data <- read.table("glommed-time-series.txt",header=T)
# Pick an odd number
fwid <- 75
movmean <- filter(data$samples,rep(1/fwid,fwid),sides=2)

png("slowdown-scattersums.png",width=800,height=800,units="px",pointsize=16)
par(mar=c(4,4,2,0))
plot(data$samples,main="Trend in sample counts in AXE experiment",xlab="Iteration number (chronological)",ylab="Sum of approximate sample counts from all 30 configurations on each iteration")
lines(movmean,lwd=5,col="red")
dev.off()

pdf("slowdown-scattersums.pdf")
par(mar=c(4,4,0.5,0.1))
plot(data$samples,xlab="Iteration number (chronological)",ylab="Sum of approximate sample counts from all 30 configurations on each iteration",cex=0.75)
lines(movmean,lwd=3,col="red")
dev.off()
