# 2013-08-26 09:37
# Review of data for time-dependency and extreme non-normality.
# All plots are written to inputdists.pdf.

# logq2 p sample
data <- read.table("data-denormalized.txt",header=T)

# Keep the smoothing bandwidth above the level of quantization error.
qe <- 1.3*0.5
# bw.nrd0 is the default estimator of density().
bw.dwf <- function(x) {
  max(qe,bw.nrd0(x))
}

pdf("inputdists.pdf")
for (logq2 in min(data$logq2):max(data$logq2)) {
  for (p in min(data$p):max(data$p)) {
    title <- sprintf("logq2=%d p=%d\n", logq2, p)
    d <- data$sample[data$logq2==logq2 & data$p==p]
    plot(d,ylab="Input data",main=title)
    plot(density(d,bw=bw.dwf(d)),main=title,lwd=2.5)
    # Discretization messes up ACF.  Add dithering.
    d <- d + runif(length(d),-qe,qe)
    acf(d,ci.type="ma",main=title)
  }
}
dev.off()
