# 2013-07-22 10:58

# Harmonize vertical scale with the previous graph
yrange <- 1515

data <- read.table("glommed-noscale-time-series.txt",header=T)
# This is extremely fiddly.
data$rownumber <- 1:nrow(data)
lm <- lm(formula=ms~rownumber, data=data)
lmout <- data.frame(rownumber=c(1,nrow(data)))
lmout$ms <- predict(object=lm, newdata=lmout)
# print (lmout$ms)

ymin <- min(data$ms)
ymax <- ymin + yrange
ylim <- c(ymin, ymax)

png("slowdown-scatterline.png",width=800,height=800,units="px",pointsize=16)
par(mar=c(4,4,2,0))
plot(data$ms,main="Trend in sample counts in AXE experiment",xlab="Iteration number (chronological)",ylab="Sum of CPU Time:Self from all 30 configurations on each iteration (ms)",ylim=ylim)
lines(x=lmout$rownumber,y=lmout$ms,lwd=5,col="red")
dev.off()

pdf("slowdown-scatterline.pdf")
par(mar=c(4,4,0.1,0.1))
plot(data$ms,xlab="Iteration number (chronological)",ylab="Sum of CPU Time:Self from all 30 configurations on each iteration (ms)",cex=0.75,ylim=ylim)
lines(x=lmout$rownumber,y=lmout$ms,lwd=3,col="red")
dev.off()
