# 2013-07-22 11:13

# Harmonize vertical scale with the previous graph
yrange <- 1515

data <- read.table("glommed-noscale-time-series.txt",header=T)
# Pick an odd number
fwid <- 75
movmean <- filter(data$ms,rep(1/fwid,fwid),sides=2)

ymin <- min(data$ms)
ymax <- ymin + yrange
ylim <- c(ymin, ymax)

png("slowdown-scattersums.png",width=800,height=800,units="px",pointsize=16)
par(mar=c(4,4,2,0))
plot(data$ms,main="Trend in sample counts in AXE experiment",xlab="Iteration number (chronological)",ylab="Sum of CPU Time:Self from all 30 configurations on each iteration (ms)",ylim=ylim)
lines(movmean,lwd=5,col="red")
dev.off()

pdf("slowdown-scattersums.pdf")
par(mar=c(4,4,0.5,0.1))
plot(data$ms,xlab="Iteration number (chronological)",ylab="Sum of CPU Time:Self from all 30 configurations on each iteration (ms)",cex=0.75,ylim=ylim)
lines(movmean,lwd=3,col="red")
dev.off()
