/**
 * Proportionate Test Launcher
 * Purpose:	Launch the proportionate test
 * 			Show the effects of self-time fragmentation (the q value) on variability
 * Built on Eclipse for Linux, Ubuntu 12.04 LTS
 * By:	Ramon Luis De Jesus
 * On:	July 10, 2013	2:30pm
 * Note:	App needs separate proportionate.apk to run.
 */
package gov.nist.proportionatelauncher;

import java.io.File;
import java.util.ArrayList;
import java.util.List;

import android.app.Activity;
import android.app.Notification;
import android.app.NotificationManager;
import android.app.PendingIntent;
import android.content.Context;
import android.content.Intent;
import android.media.RingtoneManager;
import android.os.BadParcelableException;
import android.os.Build;
import android.os.Bundle;
import android.os.Environment;
import android.os.Vibrator;
import android.support.v4.app.NotificationCompat;
import android.text.Editable;
import android.text.TextWatcher;
import android.util.Log;
import android.view.Menu;
import android.view.View;
import android.view.WindowManager;
import android.widget.CheckBox;
import android.widget.EditText;
import android.widget.ProgressBar;
import android.widget.Toast;

public class MainActivity extends Activity {

	/**
	 * Controls
	 */
	EditText etTraceName;
	EditText etTotalLoops;
	EditText etRepeatTimes;
	EditText etBufferSize;
	// EditText etTimesBigger;

	CheckBox chTestA;
	CheckBox chTestB;
	CheckBox chTestC;
	CheckBox chTestD;
	
	CheckBox chTestE;
	CheckBox chTestF;
	CheckBox chTestG;
	CheckBox chTestH;
	
	CheckBox chTestI;
	CheckBox chTestJ;
	CheckBox chTestK;
	CheckBox chTestL;
	
	CheckBox chTestM;
	CheckBox chTestN;
	CheckBox chTestO;

	static ProgressBar pbProgress;

	// To set the amount of times big for the highest q value.
	long TimesBigger = 10;

	/**
	 * Values
	 */
	public static String TraceName = "traceName";
	public static long TotalLoops = 3162280;
	public static int RepeatTimes = 1;
	public static int BufferSize = 209715200;
	public static int Seconds = 1;
	public static String PackageName = "gov.nist.proportionate";

	// To display dates on notification
	public static String DateStarted;
	public static String DateFinished;

	// Use to store and later delete our traceFiles
	public static File TracesDirectory;

	// p values
	public static Double p = 0.2;

	// d values
	public static List<TestType> dList = new ArrayList<TestType>();

	@Override
	protected void onCreate(Bundle savedInstanceState) {
		super.onCreate(savedInstanceState);
		setContentView(R.layout.activity_main);

		WhoAmI();

		// Keep screen on, even if the device its not charging.
		// Bug fixer for stops in the service.
		getWindow().addFlags(WindowManager.LayoutParams.FLAG_KEEP_SCREEN_ON);

		TracesDirectory = new File(Environment.getExternalStorageDirectory()
				+ "/Traces");
		TracesDirectory.mkdirs();

		/**
		 * Listeners
		 */

		// Checkbox's
		chTestA = (CheckBox) findViewById(R.id.chTestA);
		chTestB = (CheckBox) findViewById(R.id.chTestB);
		chTestC = (CheckBox) findViewById(R.id.chTestC);
		chTestD = (CheckBox) findViewById(R.id.chTestD);
		chTestE = (CheckBox) findViewById(R.id.chTestE);
		chTestF = (CheckBox) findViewById(R.id.chTestF);
		chTestG = (CheckBox) findViewById(R.id.chTestG);
		chTestH = (CheckBox) findViewById(R.id.chTestH);
		chTestI = (CheckBox) findViewById(R.id.chTestI);
		chTestJ = (CheckBox) findViewById(R.id.chTestJ);
		chTestK = (CheckBox) findViewById(R.id.chTestK);
		chTestL = (CheckBox) findViewById(R.id.chTestL);
		chTestM = (CheckBox) findViewById(R.id.chTestM);
		chTestN = (CheckBox) findViewById(R.id.chTestN);
		chTestO = (CheckBox) findViewById(R.id.chTestO);

		// Set the checkbox's true setting on.
		SetDefaultTests();

		pbProgress = (ProgressBar) findViewById(R.id.pbProgress);
		pbProgress.setVisibility(View.GONE);

		etTraceName = (EditText) findViewById(R.id.etTraceName);
		etTraceName.addTextChangedListener(new TextWatcher() {
			@Override
			public void afterTextChanged(Editable s) {
				try {
					if (etTraceName.getText().toString().length() > 0) {
						String x = etTraceName.getText().toString();
						if (x.length() > 0) {
							TraceName = x;
						} else {
							throw new BadParcelableException("");
						}
					} else {
						TraceName = etTraceName.getHint().toString();
					}
				} catch (Exception ex) {
					MessageBox("Invalid name for trace!");
				}
			}

			@Override
			public void beforeTextChanged(CharSequence s, int start, int count,
					int after) {
			}

			@Override
			public void onTextChanged(CharSequence s, int start, int before,
					int count) {
			}
		});

		// etTimesBigger = (EditText) findViewById(R.id.etTimesBigger);
		// etTimesBigger.addTextChangedListener(new TextWatcher() {
		// @Override
		// public void afterTextChanged(Editable s) {
		// try {
		// if (etTimesBigger.getText().toString().length() > 0) {
		// long x = Long.parseLong(etTimesBigger.getText()
		// .toString());
		// if (x > 0 && x < 2000000000) {
		// TimesBigger = x;
		// } else {
		// throw new BadParcelableException("");
		// }
		// } else {
		// TimesBigger = Long.parseLong(etTimesBigger.getHint()
		// .toString());
		// }
		// } catch (Exception ex) {
		// MessageBox("Invalid number for Times Bigger!");
		// }
		// }
		//
		// @Override
		// public void beforeTextChanged(CharSequence s, int start, int count,
		// int after) {
		// }
		//
		// @Override
		// public void onTextChanged(CharSequence s, int start, int before,
		// int count) {
		// }
		// });

		etTotalLoops = (EditText) findViewById(R.id.etTotalLoops);
		etTotalLoops.addTextChangedListener(new TextWatcher() {
			@Override
			public void afterTextChanged(Editable s) {
				try {
					if (etTotalLoops.getText().toString().length() > 0) {
						long x = Long.parseLong(etTotalLoops.getText()
								.toString());
						if (x > 0 && x < 2000000000) {
							TotalLoops = x;
						} else {
							throw new BadParcelableException("");
						}
					} else {
						TotalLoops = Long.parseLong(etTotalLoops.getHint()
								.toString());
					}
				} catch (Exception ex) {
					MessageBox("Invalid number of Loops!");
				}
			}

			@Override
			public void beforeTextChanged(CharSequence s, int start, int count,
					int after) {
			}

			@Override
			public void onTextChanged(CharSequence s, int start, int before,
					int count) {
			}
		});

		etBufferSize = (EditText) findViewById(R.id.etBufferSize);
		etBufferSize.addTextChangedListener(new TextWatcher() {
			@Override
			public void afterTextChanged(Editable s) {
				try {
					if (etBufferSize.getText().toString().length() > 0) {
						int x = Integer.parseInt(etBufferSize.getText()
								.toString());
						if (x > 0 && x < 2000000000) {
							BufferSize = x;
						} else {
							throw new BadParcelableException("");
						}
					} else {
						BufferSize = Integer.parseInt(etBufferSize.getHint()
								.toString());
					}
				} catch (Exception ex) {
					MessageBox("Invalid number for maximun trace size limit!");
				}
			}

			@Override
			public void beforeTextChanged(CharSequence s, int start, int count,
					int after) {
			}

			@Override
			public void onTextChanged(CharSequence s, int start, int before,
					int count) {
			}
		});

		etRepeatTimes = (EditText) findViewById(R.id.etRepeatTimes);
		etRepeatTimes.addTextChangedListener(new TextWatcher() {
			@Override
			public void afterTextChanged(Editable s) {
				try {
					if (etRepeatTimes.getText().toString().length() > 0) {
						int x = Integer.parseInt(etRepeatTimes.getText()
								.toString());
						if (x > 0 && x < 2000000000) {
							RepeatTimes = x;
						} else {
							throw new BadParcelableException("");
						}
					} else {
						RepeatTimes = Integer.parseInt(etRepeatTimes.getHint()
								.toString());
					}
				} catch (Exception ex) {
					MessageBox("Invalid number of Repeat Times!");
				}
			}

			@Override
			public void beforeTextChanged(CharSequence s, int start, int count,
					int after) {
			}

			@Override
			public void onTextChanged(CharSequence s, int start, int before,
					int count) {
			}
		});
	}

	@Override
	public boolean onCreateOptionsMenu(Menu menu) {
		// Inflate the menu; this adds items to the action bar if it is present.
		getMenuInflater().inflate(R.menu.main, menu);
		return true;
	}

	public void onDestroy() {
		super.onDestroy();
		System.exit(0);
	}

	/**
	 * Global Click Events
	 */
	public void btnStartClicked(View v) {
		if (PackageName != null && PackageName != "" && PackageName != "error") {

			// Add test cases to run on proportionate test
			AddValuesToList();

			if (ValidTotalLoops()) {

				// Clean old trace files with same name to skip runtime errors.
				btnCleanClicked(null);

				// Start the service.
				startService(new Intent(getBaseContext(), AppLauncher.class));
			} else {
				MessageBox("Invalid number of TotalLoops"
						+ System.getProperty("line.separator")
						+ "for test case with a total q"
						+ System.getProperty("line.separator") + "value of: \""
						+ Long.toString(QHigestValue()) + "\""
						+ System.getProperty("line.separator") + "try \""
						+ Long.toString(QHigestValue() * TimesBigger) + "\"");
			}
		}
	}

	public void btnCleanClicked(View v) {

		if (!pbProgress.isShown()) {
			pbProgress.setVisibility(View.VISIBLE);
			DeleteTraceFiles delete = new DeleteTraceFiles();
			delete.Start();
		}
	}

	public void btnExitClicked(View v) {

		Vibrate();
		finish();
	}

	/**
	 * Misc
	 */

	public void MessageBox(String message) {
		Toast.makeText(this, message, Toast.LENGTH_LONG).show();
	}

	public static void DeleteCompleted() {
		pbProgress.setVisibility(View.GONE);
	}

	public void Vibrate() {
		Vibrator v = (Vibrator) getSystemService(Context.VIBRATOR_SERVICE);
		// Vibrate for 50 milliseconds
		v.vibrate(50);
	}

	public void RaiseNotification(String titleNotification,
			String mesgNotification) {
		Intent intent = new Intent(this, NotificationReceiverActivity.class);
		@SuppressWarnings("unused")
		PendingIntent pIntent = PendingIntent.getActivity(this, 0, intent, 0);

		if (Build.VERSION.SDK_INT >= 11) {

			// Build notification
			// Actions are just fake
			Notification noti = new Notification.Builder(this)
					.setContentTitle(titleNotification)
					.setContentText(mesgNotification)
					.setSound(
							RingtoneManager
									.getDefaultUri(RingtoneManager.TYPE_NOTIFICATION))
					.setStyle(
							new Notification.BigTextStyle()
									.bigText(mesgNotification))
					.setSmallIcon(R.drawable.ic_launcher).build();

			NotificationManager notificationManager = (NotificationManager) getSystemService(NOTIFICATION_SERVICE);

			// Hide the notification after its selected
			noti.flags |= Notification.FLAG_AUTO_CANCEL;

			notificationManager.notify(0, noti);
		} else {
			NotificationCompat.Builder builder = new NotificationCompat.Builder(
					this)
					.setAutoCancel(true)
					.setContentTitle(titleNotification)
					.setContentText(mesgNotification)
					.setSound(
							RingtoneManager
									.getDefaultUri(RingtoneManager.TYPE_NOTIFICATION))
					.setSmallIcon(R.drawable.ic_launcher);

			PendingIntent in = PendingIntent.getActivity(
					getApplicationContext(), 0, intent, 0);
			builder.setContentIntent(in);

			NotificationManager notificationManager = null;
			try {
				notificationManager = (NotificationManager) getSystemService(Context.NOTIFICATION_SERVICE);
			} catch (Exception e) {
				Log.e("ERROR", e.getMessage());
			}

			try {
				notificationManager.notify(0, builder.build());
			} catch (Exception e) {
				Log.e("ERROR", e.getMessage());
			}
		}
	}

	// Set default options to test
	void SetDefaultTests() {

		chTestA.setChecked(true);
		chTestB.setChecked(true);
		chTestC.setChecked(true);
		chTestD.setChecked(true);
		chTestE.setChecked(true);
		chTestF.setChecked(true);
		chTestG.setChecked(true);
		chTestH.setChecked(true);
		chTestI.setChecked(true);
		chTestJ.setChecked(true);
		chTestK.setChecked(true);
		chTestL.setChecked(true);
	}

	// For more values on the test just add them here in the order you want them
	// to run.
	void AddValuesToList() {

		// Reset Test case's list
		dList.clear();

		if (chTestA.isChecked()) {
			TestType a = new TestType("a", 1);
			dList.add(a);
		}

		if (chTestB.isChecked()) {
			TestType b = new TestType("b", 3);
			dList.add(b);
		}

		if (chTestC.isChecked()) {
			TestType c = new TestType("c", 10);
			dList.add(c);
		}

		if (chTestD.isChecked()) {
			TestType d = new TestType("d", 32);
			dList.add(d);
		}
		if (chTestE.isChecked()) {
			TestType e = new TestType("e", 100);
			dList.add(e);
		}

		if (chTestF.isChecked()) {
			TestType f = new TestType("f", 316);
			dList.add(f);
		}

		if (chTestG.isChecked()) {
			TestType g = new TestType("g", 1000);
			dList.add(g);
		}

		if (chTestH.isChecked()) {
			TestType h = new TestType("h", 3162);
			dList.add(h);
		}
		if (chTestI.isChecked()) {
			TestType i = new TestType("i", 10000);
			dList.add(i);
		}

		if (chTestJ.isChecked()) {
			TestType j = new TestType("j", 31623);
			dList.add(j);
		}
		if (chTestK.isChecked()) {
			TestType k = new TestType("k", 100000);
			dList.add(k);
		}

		if (chTestL.isChecked()) {
			TestType l = new TestType("l", 316228);
			dList.add(l);
		}

		/**
		 * Below test cases require more speed and memory from the device to
		 * gather the tracefiles
		 */

		if (chTestM.isChecked()) {
			TestType m = new TestType("m", 1000000);
			dList.add(m);
		}

		if (chTestN.isChecked()) {
			TestType n = new TestType("n", 3162278);
			dList.add(n);
		}
		if (chTestO.isChecked()) {
			TestType o = new TestType("o", 10000000);
			dList.add(o);
		}
	}

	boolean ValidTotalLoops() {
		boolean valid = false;

		if (TotalLoops >= (QHigestValue() * TimesBigger)) {
			valid = true;
		}

		return valid;
	}

	long QHigestValue() {
		long higestValue = 0L;
		for (TestType i : dList) {
			if (higestValue < i.getValue()) {
				higestValue = i.getValue();
			}
		}
		return higestValue;
	}

	void WhoAmI() {
		Log.e("~", "************************");
		Log.d("*", "Proportionate Test Launcher");
		Log.d("*", "Purpose:	Launch the proportionate test.");
		Log.d("*",
				"Show the effects of self-time fragmentation (the q value) on variability");
		Log.d("*", "Built on Eclipse for Linux, Ubuntu 12.04 LTS");
		Log.d("*", "By:	Ramon Luis De Jesus");
		Log.d("*", "On:	July 10, 2013	2:30pm");
		Log.d("*",
				"Note:	Integer values don't matter much on MainActivity.java");
		Log.d("*",
				"Values here are set for reference or overwrite actual defaults on val's x.");
		Log.e("~", "************************");
	}

}
