#!/usr/bin/ruby
# 2013-05-28 17:06
# perf version

# This does not do the corrected sample standard deviation (n-1).
# descriptive_statistics-1.1.1.gem from https://github.com/thirtysixthspan/descriptive_statistics 2013-05-14 13:58
# gem install descriptive_statistics-1.1.1.gem
# require 'descriptive_statistics'

def sum(x)
  x.inject(:+).to_f
end

def mean(x)
  sum(x)/x.size
end

def sd(x)
  xm = mean(x)
  v = x.map{ |sample| (xm - sample) ** 2 }.inject(:+) / (x.size - 1.0)
  Math.sqrt(v)
end

# convert reads the file corresponding to q and returns a pair (actually an
# Array of size 2) of Arrays.  The first one contains the sample counts from
# fn1; the second from fn2.
def convert(logq)
  pair = Array.new(2) { Array.new }
  q = (10 ** logq + 0.5).to_i
  fname = q.to_s + "_perf.txt"
  File.open(fname,"r") do |file|
    file.lines do |line|
      line.chomp!
      if line[0] != "#" && line.size > 0
        raise "Perf input format error" if line[0] != " "
        ls = line.split(' ')
        samplecount = ls[1].to_i
        case ls.last
          when "fn1" then pair[0].push(samplecount)
	  when "fn2" then pair[1].push(samplecount)
        end
      end
    end
  end
  # FIXME for p=0
  raise "Sample count mismatch" if pair[0].size != pair[1].size
  pair
end

def dumpout(data,filename)
  File.open(filename,"w") { |file|
    file.puts "log(q) count min max mean sd"
    logq = 4.5
    while logq <= 9 do
      i = (logq * 2 - 9).to_i
      file.puts logq.to_s + " " + data[i].size().to_s + " " + data[i].min.to_s + " " + data[i].max.to_s + " " + mean(data[i]).to_s + " " + sd(data[i]).to_s
      logq += 0.5
    end
  }
end

# px10 = 0.2
data2 = Array.new(10) { Array.new }
data8 = Array.new(10) { Array.new }
logq = 4.5
while logq <= 9 do
  i = (logq * 2 - 9).to_i
  pair = convert(logq)
  data2[i] = pair[0]
  data8[i] = pair[1]
  logq += 0.5
end
dumpout(data2,"crunched-2.txt")
dumpout(data8,"crunched-8.txt")

dump = File.open("data-denormalized.txt","w")
dump.puts "logq2 p sample"
for logq2 in 9..18
  i = logq2 - 9
  data2[i].each {|x| dump.print logq2, " ", 0, " ", x, "\n" }
  data8[i].each {|x| dump.print logq2, " ", 1, " ", x, "\n" }
end
