#!/usr/bin/ruby
# 2013-05-21 13:06
# perf version

# This does not do the corrected sample standard deviation (n-1).
# descriptive_statistics-1.1.1.gem from https://github.com/thirtysixthspan/descriptive_statistics 2013-05-14 13:58
# gem install descriptive_statistics-1.1.1.gem
# require 'descriptive_statistics'

def sum(x)
  x.inject(:+).to_f
end

def mean(x)
  sum(x)/x.size
end

def sd(x)
  xm = mean(x)
  v = x.map{ |sample| (xm - sample) ** 2 }.inject(:+) / (x.size - 1.0)
  Math.sqrt(v)
end

# convert reads the file corresponding to args and returns a pair (actually an
# Array of size 2) of Arrays.  The first one contains the sample counts from
# fn1; the second from fn2.
def convert(q,smp,load)
  pair = Array.new(2) { Array.new }
  fname = q + "_" + smp + "_" + load + ".txt"
  File.open(fname,"r") do |file|
    file.lines do |line|
      line.chomp!
      if line[0] != "#" && line.size > 0
        raise "Perf input format error" if line[0] != " "
        ls = line.split(' ')
        samplecount = ls[1].to_i
        case ls.last
          when "fn1" then pair[0].push(samplecount)
	  when "fn2" then pair[1].push(samplecount)
        end
      end
    end
  end
  # FIXME for p=0
  raise "Sample count mismatch" if pair[0].size != pair[1].size
  pair
end

# i & 1   q      0=1,        1=100000
# i & 2   smp    0=nosmp,    1=smp
# i & 4   load   0=noload,   1=load
# i & 8   p      0=0.2(fn1), 1=0.8(fn2)
data = Array.new(16) { Array.new }
(0..7).each do |i|
  q    = i&1==0 ? "1"      : "100000"
  smp  = i&2==0 ? "nosmp"  : "smp"
  load = i&4==0 ? "noload" : "load"
  pair = convert(q,smp,load)
  data[i]   += pair[0]
  data[i+8] += pair[1]
end

crunched = File.open("data-summary.txt","w")
crunched.puts "q smp load p count mean sd"
dump = File.open("data-denormalized.txt","w")
dump.puts "q smp load p sample"
(0..15).each do |i|
  q    = i&1==0 ? "0" : "1"
  smp  = i&2==0 ? "0" : "1"
  load = i&4==0 ? "0" : "1"
  p    = i&8==0 ? "0" : "1"
  crunched.puts q + " " + smp + " " + load + " " + p + " " + data[i].size.to_s + " " + mean(data[i]).to_s + " " + sd(data[i]).to_s
  data[i].each {|x| dump.puts q + " " + smp + " " + load + " " + p + " " + x.to_s }
end
crunched.close
dump.close
