# 2013-05-31 15:01
# R --vanilla -f pngplot.R

# Requires plotrix package; tested plotrix_3.4-7.tar.gz
library(plotrix)

# All of these stupid fudge factors need adjusting whenever the font or plot
# size changes.
legend_vertical_fudge              <- 0.1    # lines of text? (+ = up)
x_labels_vertical_fudge            <- -17    # pixels (+ = up)
right_side_labels_horizontal_fudge <-  21    # pixels (+ = right)

data <- read.table("data-denormalized.txt",header=T)
safetymargin <- 10   # Not needed on outside margins
gapy1 <- max(data$sample[data$sample < 3000])+safetymargin
gapy2 <- min(data$sample[data$sample > 3000])-safetymargin
gaplen <- gapy2-gapy1
ylim1 <- min(data$sample)
ylim2 <- max(data$sample)-gaplen

png("compet.png",width=800,height=800,units="px",pointsize=16)
par(mar=c(2,4,5,1))
# gap, xlim, and ylim must be repeated for each one.
gap.plot (data$sample[data$q == 0 & data$p == 0],gap=c(gapy1,gapy2),xlim=c(1,400),ylim=c(ylim1,ylim2),pch=16,cex=0.5,col="black",xticlab=rep("",5),xlab="",ylab="Sample count",ytics=c(950,1000,1050,3900,3950,4000))
title ("Sample count variability comparison",line=4)
gap.plot (data$sample[data$q == 0 & data$p == 1],gap=c(gapy1,gapy2),xlim=c(1,400),ylim=c(ylim1,ylim2),pch=16,cex=0.5,col="black",add=TRUE)
gap.plot (data$sample[data$q == 1 & data$p == 0],gap=c(gapy1,gapy2),xlim=c(1,400),ylim=c(ylim1,ylim2),pch=16,cex=0.5,col="red",add=TRUE)
gap.plot (data$sample[data$q == 1 & data$p == 1],gap=c(gapy1,gapy2),xlim=c(1,400),ylim=c(ylim1,ylim2),pch=16,cex=0.5,col="red",add=TRUE)
text(x=c(50,150,250,350),y=rep(ylim1+x_labels_vertical_fudge,4),labels=c("SMP off,\nno load","SMP on,\nno load","SMP off,\nwith load","SMP on,\nwith load"),xpd=TRUE)
text(xpd=TRUE,x=400+right_side_labels_horizontal_fudge,y=(gapy2+ylim2-gaplen)/2,srt=270,labels=c("fn2, 8/10 calls"))
text(xpd=TRUE,x=400+right_side_labels_horizontal_fudge,y=(gapy1+ylim1)/2,srt=270,labels=c("fn1, 2/10 calls"))
legend("top",legend=c("10 function calls per program run",expression(paste(10^6," function calls per program run"))),pch=c(16,16),col=c("black","red"),inset=c(0,-legend_vertical_fudge),xpd=TRUE)
dev.off()
