# 2013-08-26 09:37
# Review of data for time-dependency and extreme non-normality.
# All plots are written to inputdists.pdf.

# q p load sample
data <- read.table("data-denormalized.txt",header=T)

# Keep the smoothing bandwidth above the level of quantization error.
qe <- 1.3*0.5
# bw.nrd0 is the default estimator of density().
bw.dwf <- function(x) {
  max(qe,bw.nrd0(x))
}

pdf("inputdists.pdf")
for (q in min(data$q):max(data$q)) {
  for (load in min(data$load):max(data$load)) {
    for (p in min(data$p):max(data$p)) {
      title <- sprintf("q=%d load=%d p=%d\n", q, load, p)
      d <- data$sample[data$q==q & data$load==load & data$p==p]
      plot(d,ylab="Input data",main=title)
      plot(density(d,bw=bw.dwf(d)),main=title,lwd=2.5)
      # Discretization messes up ACF.  Add dithering.
      d <- d + runif(length(d),-qe,qe)
      acf(d,ci.type="ma",main=title)
    }
  }
}
dev.off()
