# 2013-07-09 16:07

# Requires plotrix package; tested plotrix_3.4-7.tar.gz
library(plotrix)

data <- read.table("data-denormalized.txt",header=T)
safetymargin <- 100   # Not needed on outside margins
# Not working for these data
# cutoff <- (max(data$sample)+min(data$sample))/2.0
cutoff <- 1250
gapy1 <- max(data$sample[data$sample < cutoff])+safetymargin
gapy2 <- min(data$sample[data$sample > cutoff])-safetymargin
gaplen <- gapy2-gapy1
ylim1 <- min(data$sample)
ylim2 <- max(data$sample)-gaplen
xlims <- c(1,410)
ylims <- c(ylim1,ylim2)

makefile <- function(ispdf) {
  if (ispdf) {
    pdf("compet.pdf")
    par(mar=c(2,4,4,1))
    legend_vertical_fudge              <- 0.12   # lines of text? (+ = up)
    x_labels_vertical_fudge            <- -180   # pixels (+ = up)
    right_side_labels_horizontal_fudge <-  23    # pixels (+ = right)
    cexval <- 0.5
  } else {
    png("compet.png",width=800,height=800,units="px",pointsize=16)
    par(mar=c(2,4,5,1))
    legend_vertical_fudge              <- 0.1    # lines of text? (+ = up)
    x_labels_vertical_fudge            <- -175    # pixels (+ = up)
    right_side_labels_horizontal_fudge <-  21    # pixels (+ = right)
    cexval <- 0.5
  }

  # gap, xlim, and ylim must be repeated for each one.
  gap.plot (x=1:410,y=data$sample[data$q == 0 & data$p == 0],gap=c(gapy1,gapy2),xlim=xlims,ylim=ylims,pch=16,cex=cexval,col="black",xticlab=rep("",3),xtics=c(0,205,410),xlab="",ylab="Approximate sample count",ytics=c(400,800,1800,2200,2600,3000,3400))
  if (!ispdf) {
    title ("Sample count variability with competing loads (AXE)",line=4)
  }
  gap.plot (x=1:410,y=data$sample[data$q == 0 & data$p == 1],gap=c(gapy1,gapy2),xlim=xlims,ylim=ylims,pch=16,cex=cexval,col="black",add=TRUE)
  gap.plot (x=1:410,y=data$sample[data$q == 1 & data$p == 0],gap=c(gapy1,gapy2),xlim=xlims,ylim=ylims,pch=16,cex=cexval,col="red",add=TRUE)
  gap.plot (x=1:410,y=data$sample[data$q == 1 & data$p == 1],gap=c(gapy1,gapy2),xlim=xlims,ylim=ylims,pch=16,cex=cexval,col="red",add=TRUE)
  text(x=c(102.5,307.5),y=rep(ylim1+x_labels_vertical_fudge,2),labels=c("SMP on,\nno load","SMP off,\nwith load"),xpd=TRUE)
  text(xpd=TRUE,x=410+right_side_labels_horizontal_fudge,y=(gapy2+ylim2-gaplen)/2,srt=270,labels=c("fn2, 8/10 calls"))
  text(xpd=TRUE,x=410+right_side_labels_horizontal_fudge,y=(gapy1+ylim1)/2,srt=270,labels=c("fn1, 2/10 calls"))
  legend("top",legend=c("10 function calls per program run",expression(paste(10^6," function calls per program run"))),pch=c(16,16),col=c("black","red"),inset=c(0,-legend_vertical_fudge),xpd=TRUE)
  dev.off()
}

makefile(F)
makefile(T)
