# 2013-08-21 09:53
# bootstrap-run.R runs MCM and produces bootstrap-data-summary.txt.
# This script reads that file and produces the plots.

# Requires plotrix package; tested plotrix_3.4-7.tar.gz
library(plotrix)

stats <- read.table("bootstrap-data-summary.txt",header=T)

optnames <- c("1-gprof","2-perf","3-perf-PEBS","4-operf","5-opcontrol","6-perf")
dosubplot <- function(dir,opt) {
  substats <- stats[stats$dir==dir & stats$opt==opt,]
  op <- par(mar=c(0,1,1,0),mgp=c(0,0,0))
  ymax=max(substats$meanhi)
  plot(substats$mean,xaxt="n",xlab="",ylab="",type="p",pch=20,ylim=c(0,ymax),main=optnames[opt])
  arrlen <- 0.04
  arrows(substats$fn,substats$meanlo,substats$fn,substats$meanhi,angle=90,code=3,length=arrlen,col="black")
}

pdf('mean-bootstrap.pdf',height=6.5,width=9)
par(mfrow=c(3,6))
for (dir in min(stats$dir):max(stats$dir)) {
  for (opt in min(stats$opt):max(stats$opt)) {
    dosubplot(dir,opt)
  }
}
dev.off()

png("mean-bootstrap.png",width=800,height=800,units="px",pointsize=16)
par(mfrow=c(3,6))
for (dir in min(stats$dir):max(stats$dir)) {
  for (opt in min(stats$opt):max(stats$opt)) {
    dosubplot(dir,opt)
  }
}
dev.off()
