# 2013-08-26 09:37
# Review of data for time-dependency and extreme non-normality.
# All plots are written to inputdists.pdf.

# dir opt fn sample
data <- read.table("data-denormalized.txt",header=T)

# Keep the smoothing bandwidth above the level of quantization error.
qe <- 0.5
# bw.nrd0 is the default estimator of density().
bw.dwf <- function(x) {
  max(qe,bw.nrd0(x))
}

pdf("inputdists.pdf")
for (dir in min(data$dir):max(data$dir)) {
  for (opt in min(data$opt):max(data$opt)) {
    for (fn in min(data$fn):max(data$fn)) {
      title <- sprintf("dir=%d opt=%d fn=%d\n", dir, opt, fn)
      d <- data$sample[data$dir==dir & data$opt==opt & data$fn==fn]
      plot(d,ylab="Input data",main=title)
      plot(density(d,bw=bw.dwf(d)),main=title,lwd=2.5)
      # Discretization messes up ACF.  Add dithering.
      d <- d + runif(length(d),-qe,qe)
      acf(d,ci.type="ma",main=title)
    }
  }
}
dev.off()
