# 2013-07-31 15:06

# factor 1:  3 level of val1 configuration
# factor 2:  6 levels of program compile options x profiling options
# factor 3:  function ID (function1..5, plus main and other)

dotable <- function(dumpfile,infilename,factor1,factor2) {
  # Experimental data (100 rows of sample counts, 1 column per function).
  t <- read.table(infilename,header=T)
  trowcount <- nrow(t)
  # factor1 factor2 factor3 samples
  for (y in 1:nrow(t)) {
    for (x in 1:ncol(t)) {
      cat(sprintf("%d %d %d %d\n", factor1, factor2, x, t[y,x]),file=dumpfile)
    }
  }
}

# Do all tables in one of the three directories.
dodir <- function(dumpfile,dir,factor1) {
  setwd(dir)
  # These are in order of the level of compile options x prof tools, 1..6
  dotable(dumpfile,"val1_gprof_Rtable.txt",    factor1,1)
  dotable(dumpfile,"val1_perf_Rtable.txt",     factor1,2)
  dotable(dumpfile,"val1_perf-PEBS_Rtable.txt",factor1,3)
  dotable(dumpfile,"val1_operf_Rtable.txt",    factor1,4)
  dotable(dumpfile,"val1_oprofile_Rtable.txt", factor1,5)
  dotable(dumpfile,"val1_perf-fp_Rtable.txt",  factor1,6)
}

dumpfile <- file("/home/dflater/SYNC/ITM/pubs/Uncert_reboot/val1_anomaly/data-denormalized.txt",open="wt")
cat(sprintf("dir opt fn sample\n"),file=dumpfile)
dodir(dumpfile,"/home/dflater/SYNC/ITM/pubs/Uncert_reboot/val1_anomaly/val1_original",1)
dodir(dumpfile,"/home/dflater/SYNC/ITM/pubs/Uncert_reboot/val1_anomaly/val1_forward",2)
dodir(dumpfile,"/home/dflater/SYNC/ITM/pubs/Uncert_reboot/val1_anomaly/val1_reverse",3)
close(dumpfile)
