# 2013-08-01 09:31

# Bare hexadecimal addresses are read in as strings.
ts_s <- read.table("time_series.txt", col.names=c("IP"))
# hist won't work on strings.  Convert to ints.
ts_i <- as.integer(paste("0x",ts_s$IP,sep=""))

# Draw histogram with a bucket for each address.
# border=NA makes the non-adjustable-width borders go away entirely.
pdf('hist257.pdf')
fontsize <- 0.8
par(mar=c(1.8,1.8,0,0.2),mgp=c(0.6,0.6,0))
hist (ts_i, breaks=(min(ts_i)-0.5):(max(ts_i)+0.5), xlab="Instruction pointer", ylab="Count", col="blue", border=NA, xaxt="n", yaxt="n", main="", cex.lab=fontsize, cex.axis=fontsize)
iplabs=seq(min(ts_i),max(ts_i)+1,by=0x10)
axis(1,pos=-175,at=iplabs,labels=as.hexmode(iplabs),cex.axis=fontsize)
axis(2,pos=0x4006e0-0.5,at=seq(0,80000,20000),cex.axis=fontsize)
dev.off()
